Changes to Models
=================

Normally, all changes to your model files will be overwritten, when you generate the models. You have the option to create a backup when generating models (backupExistingFile), but it is much nicer when changes are automatically merged.

This directory contains a simple example how you can manage your model changes. It contains two scripts:

 * `schema-export` updates your model files, after you made changes to your model in MySQL Workbench
 * `update-model-diff` updates your patch file, after you made changes to your generated model files

These script assume you work with git.

When you made changes to the generated models, commit them to git. There is no need to push the changes yet, as you still need to update the patch file. A Workflow could look like this:

    vim Model/User.php
    # modify the model and save it
    git commit -am "Changes the model"
    ./update-model-diff
    # model-changes.diff was updated
    git commit -a --amend
    # amend the last commit and add the change to the patch file

You can take a look at Model/User.php. It contains a __toString() method which is not generated by the schema-exporter. But when calling `./update-model` this method will reappear in the PHP file.
